//
//  LLEventsView.m
//  LuckyLaps
//
//  Created by UCS on 2/6/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "LLEventsView.h"
#import "Event.h"
#import "UCSAppDelegate.h"
#import "Driver.h"
#import "LLDriverList.h"
#import "LLScoresView.h"
#import "LLPrizesViewViewController.h"
#import "LLCustomSectionHeader.h"
#import "LLCustomCellView.h"
#import "HTBannerView.h"
#import "LLClaimingPrizesViewViewController.h"
@implementation LLEventsView

@synthesize eventTB = _eventTB;
@synthesize anEvent = _anEvent;
@synthesize actIndicator = _actIndicator;
@synthesize loadingView = _loadingView;
@synthesize appDelegate = _appDelegate;
@synthesize jsonFeed = _jsonFeed;
@synthesize drivers = _drivers;
@synthesize fromHistory = _fromHistory;

NSMutableData *responseData;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        
        self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bodyBg.jpg"]];
        self.anEvent = [[Event alloc]init];
        self.drivers = [[NSMutableArray alloc] init];
        //[self.navigationItem.leftBarButtonItem setTintColor:[UIColor whiteColor]];
        //[self.navigationItem.rightBarButtonItem setTintColor:[UIColor whiteColor]];

    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
     self.appDelegate = (UCSAppDelegate *)[[UIApplication sharedApplication]delegate];
    self.eventTB.backgroundColor = [UIColor clearColor];

}

-(void) viewWillAppear:(BOOL)animated
{
 
    if(self.fromHistory)
        self.title = @"Race Info";
    else
        self.title = @"Current Race";
    [self setDrivers:[Driver getDriversForEvent:self.anEvent.eventId]];

    [self.eventTB reloadData];
        
}

#pragma mark -
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark -
#pragma mark TableView Delegate Methods
// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    if(self.fromHistory) return 7;
    return 5;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier];
        // cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        //cell.selectedBackgroundView = [[LLCustomCellView alloc] init];
        //cell.backgroundView = [[LLCustomCellView alloc] init];
        
        
    }
    cell.textLabel.textColor = [UIColor whiteColor];
    cell.detailTextLabel.textColor = [UIColor lightGrayColor];

    if(indexPath.row == 0)
    {
        // ////NSLog(@"Location : %@",self.anEvent.eventLocation);
        cell.textLabel.text = @"Location: ";
       cell.detailTextLabel.text = self.anEvent.eventLocation;
        cell.imageView.image = [UIImage imageNamed:@"location_event.png"];
        
        
    }
    if(indexPath.row == 1)
    {

        NSDate *eventDate;
        NSDateFormatter *format = [[NSDateFormatter alloc] init];
        [format setDateFormat:@"yyyy-MM-dd"];
        eventDate = [format dateFromString:self.anEvent.eventDate];
        [format setDateFormat:@"MM-dd-yyyy"];
        NSString *dateString = [format stringFromDate:eventDate];
        cell.textLabel.text = @"Date: ";
         cell.detailTextLabel.text = dateString;
        cell.imageView.image = [UIImage imageNamed:@"date_gray_event.png"];
       
    }
    if(indexPath.row == 2)
    {

        NSArray *timeArray = [self.anEvent.eventTime componentsSeparatedByString: @":"];
        NSString *newTime;
        if([[timeArray objectAtIndex:0] intValue] > 12 )
        {
            int newHour = [[timeArray objectAtIndex:0] intValue] - 12 ;
            
            if([[timeArray objectAtIndex:1] intValue] < 10)
                newTime = [NSString stringWithFormat:@"%d:0%d PM - ",newHour,[[timeArray objectAtIndex:1] intValue] ];
            else
               newTime = [NSString stringWithFormat:@"%d:%d PM - ",newHour,[[timeArray objectAtIndex:1] intValue] ];
            
        }
        else
        {
            if([[timeArray objectAtIndex:1] intValue] < 10)
                newTime = [NSString stringWithFormat:@"%d:0%d AM - ",[[timeArray objectAtIndex:0] intValue],[[timeArray objectAtIndex:1] intValue] ];
            else
                newTime = [NSString stringWithFormat:@"%d:%d AM - ",[[timeArray objectAtIndex:0] intValue],[[timeArray objectAtIndex:1] intValue] ];

        }
        
        cell.textLabel.text = @"Time: ";
        
        cell.detailTextLabel.text =newTime;
        //UIImageView *iv = [[UIImageView alloc] initWithFrame:CGRectMake(10.0,10.0,25, 25)];
       
       // cell.imageView.frame = iv.frame;
         cell.imageView.image = [UIImage imageNamed:@"time_event2.png"];
       
         
        cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@" "];
        switch (self.anEvent.timeZone) {
            case 0:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"EST"];
                
                break;
            case 1:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"CST"];
                
                break;
            case 2:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"MST"];
                
                break;
            case 3:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"PST"];
                
                break;
            case 4:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"HST"];
                
                break;
            case 5:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@"AKST"];
                
                break;
                
            default:cell.detailTextLabel.text = [cell.detailTextLabel.text stringByAppendingString:@" "];
                break;
        }

        
    }
    if(indexPath.row == 3)
    {
        
        cell.textLabel.text = @"Drivers: ";
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        cell.imageView.image = [UIImage imageNamed:@"helmet_event.png"];
               
    }
    if(indexPath.row == 4)
    {
        
        cell.textLabel.text = @"Prize List: ";
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        cell.imageView.image = [UIImage imageNamed:@"prizes_event2.png"];
        
    }
    
    if(self.fromHistory)
    {
        if(indexPath.row == 5)
        {
            cell.textLabel.text = @"Scores: ";
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
             cell.imageView.image = [UIImage imageNamed:@"scores_event.png"];

        }
        if(indexPath.row == 6)
        {
            cell.textLabel.text = @"Claim Prizes: ";
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
            cell.imageView.image = [UIImage imageNamed:@"prizes_event2.png"];
            
        }
    }

    cell.textLabel.backgroundColor = [UIColor clearColor];
    cell.detailTextLabel.backgroundColor = [UIColor clearColor];
    
    return cell;
}

 - (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
 {
 
    if(indexPath.row == 3)
    {
     LLDriverList *dl = [[LLDriverList alloc] initWithNibName:@"LLDriverList" bundle:nil];
      //////NSLog(@"Drivers array in Events View%@",self.drivers );
     dl.drivers = self.drivers;
     dl.eventName = self.anEvent.eventName;
 
 
     [self.navigationController pushViewController:dl animated:YES];
    }
     
     if(indexPath.row == 4)
     {
         LLPrizesViewViewController *pr = [[LLPrizesViewViewController alloc] initWithNibName:@"LLPrizesViewViewController" bundle:nil];
         //NSLog(@"EventID = %d",self.anEvent.eventId);
         pr.eventId = self.anEvent.eventId;
         pr.hasMidRaceResults = self.anEvent.hasMidRaceResults;
         [self.navigationController pushViewController:pr animated:YES];
     }
     
     
     if(self.fromHistory)
     {
         if(indexPath.row == 5)
         {
             LLScoresView *sc = [[LLScoresView alloc] initWithNibName:@"LLScoresView" bundle:nil];
             sc.anEvent = [[Event alloc] init];
             sc.anEvent = self.anEvent;
             sc.isFromHistory = YES;
             [self.navigationController pushViewController:sc animated:YES];
         }
         if(indexPath.row == 6)
         {
             LLClaimingPrizesViewViewController *pr = [[LLClaimingPrizesViewViewController alloc] initWithNibName:@"LLClaimingPrizesViewViewController" bundle:nil andEvent:self.anEvent];
                          
             [self.navigationController pushViewController:pr animated:YES];
         }
     }
 }

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
{   
    return 55.0f;
}
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    
    
    UIView *aView = [[UIView alloc] initWithFrame:CGRectMake(0.0, 0.0, self.eventTB.frame.size.width, 70.0)];
    
    LLCustomSectionHeader *headerView = [[ LLCustomSectionHeader alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 58.0)];
    headerView.headerText.text = self.anEvent.eventName;
    [aView addSubview:headerView];
    return aView;
}
- (void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    [cell setBackgroundColor:[UIColor colorWithRed:57.0/255.0 green:61.0/255.0 blue:64.0/255.0 alpha:1.0]];
}

#pragma mark - Banner View
-(void)addBannerView : (id)sender
{
    CGRect frame = CGRectMake(0.0, (self.view.bounds.origin.y - 50)+ 50.0, 320.0, 50.0);
    self.bnView = [[HTBannerView alloc] initWithFrame:frame andText:@"2 New Updates Available"];
    UITapGestureRecognizer *recognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTap:)];
    recognizer.delegate = self;
    recognizer.numberOfTapsRequired = 1;
    //tapGesture.numberOfTouchesRequired =2;
    
    [[[self.appDelegate.navCtrl topViewController] view] addGestureRecognizer:recognizer];
    [self.bnView addViewToSuperView:[self.appDelegate.navCtrl view]];
    self.updateAlertPresented = YES;
    [self performSelector:@selector(removeBannerView) withObject:nil afterDelay:10.0];
}
-(void)removeBannerView
{
    NSLog(@"Removing banner View");
    [self.bnView removeViewFromSuperView];
    self.updateAlertPresented = NO;
}


@end
